
function onLoad()
{
	loadTags();
}

//
// Loads the tags
//
function loadTags()
{
	try
	{
	    var tagsTree = document.getElementById('delicious-sidebar-tags-tree');
		var xmlDOM = deliciousService.getTags();
	    
	    var root = xmlDOM.documentElement;
	    var myTags = root.getElementsByTagName("tag");
        var treeChildren = document.getElementById('delicious-sidebar-tags-tree-children');//document.createElement('treechildren');
        
	    for (var i = 0; i < myTags.length; i++) 
	    {
	        var tagName = myTags[i].getAttribute("tag");
	        var count = myTags[i].getAttribute("count");
	        
            var item = document.createElement('treeitem');
            var row = document.createElement('treerow');
            //row.setAttribute('id',rowID);
            
            var cell = document.createElement('treecell');
            cell.setAttribute('label', tagName);
            row.appendChild(cell);
            
            var cell = document.createElement('treecell');
            cell.setAttribute('label', count);
            row.appendChild(cell);
            
            item.appendChild(row);
            
	        //tagsTree.appendItem(tagName, tagName);
            treeChildren.appendChild(item);
	    }
        //tagsTree.appendChild(treeChildren);
	}
	catch(e)
	{
		alert(e);
	}
}


function reloadTags()
{
    var tree = document.getElementById('delicious-sidebar-tags-tree-children');
    var items = tree.getElementsByTagName('treeitem');
    var itemCount = items.length - 1;
    
    for(i = itemCount; i >= 0; i--) {
        tree.removeChild(items[i]);
    };
    loadTags();
}

function clearFeeds()
{
	var tree = document.getElementById('delicious-sidebar-bookmarks-tree');

	var datasources = tree.database.GetDataSources();
	while(datasources.hasMoreElements()){
	        var datasource = datasources.getNext();
	        datasource = datasource.QueryInterface(Components.interfaces.nsIRDFDataSource);
	        tree.database.RemoveDataSource(datasource);
	}

	tree.builder.rebuild();
}

//
// Reloads the selected feeds
//
function reloadFeeds()
{
	var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
	var datasources = tree.database.GetDataSources();
	
	alert("Reload is not working currently. 304 HTTP code is not handled correctly by Mozilla.\nWorking on a fix.");
    
    // Possible solution??
	while(datasources.hasMoreElements()){
	        var datasource = datasources.getNext();
	        datasource = datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	        // reload asyncronously. Does not seem to know what 304 is
	        datasource.Refresh(false);
	}
}

//
// Displays the selected tags
//
function loadSelectedTag()
{
    const tagsTree = document.getElementById('delicious-sidebar-tags-tree');
    const tag = tagsTree.view.getCellText(tagsTree.currentIndex, "name");
    
    if(tagsTree.selectedCount == 0)
    {
        alert("Click on a tag");
        return false;
    }
    else
    {
    	loadFeed(tag);
        return true;
    }
}

//
// Load a feed into the tree
//
function loadFeed(tag)
{
	try
	{
		var username = deliciousService.getUsername();
		var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
		var feedUrl = "http://del.icio.us/rss/" + username;
		
		if(tag != null)
		{
			feedUrl += "/" + tag;
		}
		
		var datasource = rdfService.GetDataSource(feedUrl);
		
		var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
		
		// This has to match the channel in the feed
		tree.ref = "http://del.icio.us/" + username;
		tree.database.AddDataSource(datasource);
		tree.builder.rebuild();
	}
	catch(e)
	{
		alert(e);
	}
}

//
// Load link
//
function onDblClick()
{
    var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
    var bookmarkUrl = tree.view.getCellText(tree.currentIndex, "link_column");
    window._content.document.location.href = bookmarkUrl;
    return;
}